{
    "scan": {
        "analyzer-version-clang": "18.1.2",
        "analyzer-version-clippy": "1.79.0",
        "analyzer-version-coverity": "2024.3.0",
        "analyzer-version-cppcheck": "2.14.1",
        "analyzer-version-gcc": "14.1.1",
        "analyzer-version-gcc-analyzer": "14.1.1",
        "analyzer-version-shellcheck": "0.9.0",
        "analyzer-version-snyk-code": "1.1233.0",
        "analyzer-version-unicontrol": "0.0.2",
        "enabled-plugins": "clang, clippy, coverity, cppcheck, gcc, shellcheck, snyk, unicontrol",
        "exit-code": 1,
        "host": "osh-worker-005.osh-001.prod.iad2.dc.redhat.com",
        "known-false-positives": "/usr/share/csmock/known-false-positives.js",
        "known-false-positives-rpm": "known-false-positives-2.2.0.20240703.103728.gbf0dd0b-1.el9.noarch",
        "mock-config": "rhel-10-beta-x86_64",
        "project-name": "cryptsetup-2.8.0-1.fc39",
        "snyk-scanned-files-coverage": 85,
        "snyk-scanned-files-success": 139,
        "snyk-scanned-files-total": 162,
        "store-results-to": "/tmp/tmp7gr4uo4o/cryptsetup-2.8.0-1.fc39.tar.xz",
        "time-created": "2024-07-12 11:38:19",
        "time-finished": "2024-07-12 11:41:26",
        "tool": "csmock",
        "tool-args": "'/usr/bin/csmock' '-r' 'rhel-10-beta-x86_64' '-t' 'coverity,clang,shellcheck,gcc,clippy,unicontrol,snyk,cppcheck' '-o' '/tmp/tmp7gr4uo4o/cryptsetup-2.8.0-1.fc39.tar.xz' '--keep-going' '--use-host-cppcheck' '--gcc-analyze' '--unicontrol-notests' '--unicontrol-bidi-only' '/tmp/tmp7gr4uo4o/cryptsetup-2.8.0-1.fc39.src.rpm'",
        "tool-version": "csmock-3.6.0.20240621.181148.g9f7c028.internal-1.el9"
    },
    "defects": [
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 190,
            "tool": "snyk-code",
            "hash_v1": "5474460aa5e8a88e07db30769624bf09e6fcd8d8",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/lib/utils.c",
                    "line": 282,
                    "column": 16,
                    "h_size": 1,
                    "event": "warning[cpp/IntegerOverflow]",
                    "message": "Unsanitized input from a file flows into a subtraction operator (-), where it is used in integer arithmetic. This may result in an integer overflow vulnerability.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  280|   \t\t\t/* char_to_read = min(key_size - i, buflen - i) */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  281|   \t\t\tchar_to_read = key_size < buflen ?",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  282|-> \t\t\t\tkey_size - i : buflen - i;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  283|   \t\t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  284|   \t\tchar_read = read_buffer(fd, &pass[i], char_to_read);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 190,
            "tool": "snyk-code",
            "hash_v1": "5474460aa5e8a88e07db30769624bf09e6fcd8d8",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/lib/utils.c",
                    "line": 282,
                    "column": 29,
                    "h_size": 1,
                    "event": "warning[cpp/IntegerOverflow]",
                    "message": "Unsanitized input from a file flows into a subtraction operator (-), where it is used in integer arithmetic. This may result in an integer overflow vulnerability.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  280|   \t\t\t/* char_to_read = min(key_size - i, buflen - i) */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  281|   \t\t\tchar_to_read = key_size < buflen ?",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  282|-> \t\t\t\tkey_size - i : buflen - i;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  283|   \t\t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  284|   \t\tchar_read = read_buffer(fd, &pass[i], char_to_read);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 190,
            "tool": "snyk-code",
            "hash_v1": "1709f0f281f1e50818bbe4b6706953fb211dc70b",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/lib/utils_keyring.c",
                    "line": 98,
                    "column": 38,
                    "h_size": 2,
                    "event": "warning[cpp/IntegerOverflow]",
                    "message": "Unsanitized input from a file flows into a subtraction operator (-), where it is used in integer arithmetic. This may result in an integer overflow vulnerability.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   96|   \tn = sscanf(line, \"%x %*s %*u %*s %*x %*d %*d %40s %n\",",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   97|   \t\t\t&id, typebuf, &ndesc);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   98|-> \tif (n == 2 && ndesc > 0 && ndesc <= cp - line) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   99|   \t\tif (strcmp(typebuf, type) != 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  100|   \t\t\treturn 0;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 190,
            "tool": "snyk-code",
            "hash_v1": "bc56ded2cb6a9a5a25f15b337f472c96479ec1db",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/lib/utils_keyring.c",
                    "line": 160,
                    "column": 54,
                    "h_size": 10,
                    "event": "warning[cpp/IntegerOverflow]",
                    "message": "Unsanitized input from a file flows into a subtraction operator (-), where it is used in integer arithmetic. This may result in an integer overflow vulnerability.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  158|   \t\treturn 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  159|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  160|-> \twhile ((n = read(f, buf + buffer_len, sizeof(buf) - buffer_len - 1)) > 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  161|   \t\t/* coverity[overflow:FALSE] */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  162|   \t\tbuffer_len += (size_t)n;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 190,
            "tool": "snyk-code",
            "hash_v1": "b6cc0bfa80e8fc4834a74c338c95455773ebbec6",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/misc/keyslot_checker/chk_luks_keyslots.c",
                    "line": 150,
                    "column": 37,
                    "h_size": 3,
                    "event": "warning[cpp/IntegerOverflow]",
                    "message": "Unsanitized input from a file flows into an addition operator (+), where it is used in integer arithmetic. This may result in an integer overflow vulnerability.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  148|   \tdone = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  149|   \twhile (len - done >= 16) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  150|-> \t\thexdump_line(out, address + done, buf + done);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  151|   \t\tdone += 16;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  152|   \t}",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 190,
            "tool": "snyk-code",
            "hash_v1": "1502c286746d87a5bf08a29d168563f155985b55",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/misc/keyslot_checker/chk_luks_keyslots.c",
                    "line": 212,
                    "column": 6,
                    "h_size": 14,
                    "event": "warning[cpp/IntegerOverflow]",
                    "message": "Unsanitized input from a file flows into an addition operator (+), where it is used in integer arithmetic. This may result in an integer overflow vulnerability.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  210|   \t\t\t\tif (verbose) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  211|   \t\t\t\t\tfprintf(out, \"  Binary dump:\\n\");",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  212|-> \t\t\t\t\thexdump_sector(out, buffer, (uint64_t)ofs, sector_size);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  213|   \t\t\t\t\tfprintf(out,\"\\n\");",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  214|   \t\t\t\t}",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 190,
            "tool": "snyk-code",
            "hash_v1": "962c5789a06d09f44d6ef6d85b50882559fdd996",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/lib/utils_keyring.c",
                    "line": 93,
                    "column": 7,
                    "h_size": 4,
                    "event": "warning[cpp/IntegerOverflow]",
                    "message": "Unsanitized input from a file flows into an addition operator (+), where it is used in integer arithmetic. This may result in an integer overflow vulnerability.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   91|   \tassert(desc);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   92|   \tdlen = strlen(desc);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   93|-> \tcp = line + strlen(line);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   94|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   95|   \tndesc = 0;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 190,
            "tool": "snyk-code",
            "hash_v1": "b2420907187a4f1bd72ca85614be1a6ebf12e3ce",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/lib/utils_keyring.c",
                    "line": 160,
                    "column": 22,
                    "h_size": 3,
                    "event": "warning[cpp/IntegerOverflow]",
                    "message": "Unsanitized input from a file flows into an addition operator (+), where it is used in integer arithmetic. This may result in an integer overflow vulnerability.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  158|   \t\treturn 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  159|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  160|-> \twhile ((n = read(f, buf + buffer_len, sizeof(buf) - buffer_len - 1)) > 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  161|   \t\t/* coverity[overflow:FALSE] */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  162|   \t\tbuffer_len += (size_t)n;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 190,
            "tool": "snyk-code",
            "hash_v1": "b2420907187a4f1bd72ca85614be1a6ebf12e3ce",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/lib/utils_keyring.c",
                    "line": 160,
                    "column": 28,
                    "h_size": 10,
                    "event": "warning[cpp/IntegerOverflow]",
                    "message": "Unsanitized input from a file flows into an addition operator (+), where it is used in integer arithmetic. This may result in an integer overflow vulnerability.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  158|   \t\treturn 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  159|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  160|-> \twhile ((n = read(f, buf + buffer_len, sizeof(buf) - buffer_len - 1)) > 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  161|   \t\t/* coverity[overflow:FALSE] */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  162|   \t\tbuffer_len += (size_t)n;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 416,
            "tool": "snyk-code",
            "hash_v1": "7f36e39495a6ae3bf0cc5e9ba394c1285a4ea550",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/api-test-2.c",
                    "line": 549,
                    "column": 18,
                    "h_size": 8,
                    "event": "note[cpp/UseAfterFree/test]",
                    "message": "Use after free. DEVICE_1 is used in global::loop_device after it may already have been freed with call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  547|   \t\tloop_detach(THE_LOOP_DEV);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  548|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  549|-> \tif (loop_device(DEVICE_1))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  550|   \t\tloop_detach(DEVICE_1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  551|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 416,
            "tool": "snyk-code",
            "hash_v1": "9ac1c09399e43491a8c79b6fc27b23e666eb822c",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/api-test.c",
                    "line": 186,
                    "column": 18,
                    "h_size": 8,
                    "event": "note[cpp/UseAfterFree/test]",
                    "message": "Use after free. DEVICE_1 is used in global::loop_device after it may already have been freed with call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  184|   \t\tloop_detach(THE_LOOP_DEV);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  185|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  186|-> \tif (loop_device(DEVICE_1))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  187|   \t\tloop_detach(DEVICE_1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  188|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 416,
            "tool": "snyk-code",
            "hash_v1": "ad34c92d0a4fd9c368af43acfc5c6f76fec3cde5",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/api-test-2.c",
                    "line": 550,
                    "column": 15,
                    "h_size": 8,
                    "event": "note[cpp/UseAfterFree/test]",
                    "message": "Use after free. DEVICE_1 is used in global::loop_detach after it may already have been freed with call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  548|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  549|   \tif (loop_device(DEVICE_1))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  550|-> \t\tloop_detach(DEVICE_1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  551|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  552|   \tif (loop_device(DEVICE_2))",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 416,
            "tool": "snyk-code",
            "hash_v1": "104c644e56af303215449aec68e36c9c2ecb6ac3",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/api-test.c",
                    "line": 187,
                    "column": 15,
                    "h_size": 8,
                    "event": "note[cpp/UseAfterFree/test]",
                    "message": "Use after free. DEVICE_1 is used in global::loop_detach after it may already have been freed with call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  185|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  186|   \tif (loop_device(DEVICE_1))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  187|-> \t\tloop_detach(DEVICE_1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  188|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  189|   \tif (loop_device(DEVICE_2))",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 416,
            "tool": "snyk-code",
            "hash_v1": "be1533032bdae0a1c322a40c35ed80cae20d6519",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/api-test-2.c",
                    "line": 552,
                    "column": 18,
                    "h_size": 8,
                    "event": "note[cpp/UseAfterFree/test]",
                    "message": "Use after free. DEVICE_2 is used in global::loop_device after it may already have been freed with call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  550|   \t\tloop_detach(DEVICE_1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  551|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  552|-> \tif (loop_device(DEVICE_2))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  553|   \t\tloop_detach(DEVICE_2);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  554|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 416,
            "tool": "snyk-code",
            "hash_v1": "937b407a035031380bc4fcea7e84696b7bae429f",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/api-test.c",
                    "line": 189,
                    "column": 18,
                    "h_size": 8,
                    "event": "note[cpp/UseAfterFree/test]",
                    "message": "Use after free. DEVICE_2 is used in global::loop_device after it may already have been freed with call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  187|   \t\tloop_detach(DEVICE_1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  188|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  189|-> \tif (loop_device(DEVICE_2))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  190|   \t\tloop_detach(DEVICE_2);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  191|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 416,
            "tool": "snyk-code",
            "hash_v1": "5b6c458598c711e6af87b629ee1306a910cc9a04",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/api-test-2.c",
                    "line": 553,
                    "column": 15,
                    "h_size": 8,
                    "event": "note[cpp/UseAfterFree/test]",
                    "message": "Use after free. DEVICE_2 is used in global::loop_detach after it may already have been freed with call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  551|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  552|   \tif (loop_device(DEVICE_2))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  553|-> \t\tloop_detach(DEVICE_2);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  554|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  555|   \tif (loop_device(DEVICE_3))",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 416,
            "tool": "snyk-code",
            "hash_v1": "a7254c36aedf1d1201b042b03e07aff4f35a0bb8",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/api-test.c",
                    "line": 190,
                    "column": 15,
                    "h_size": 8,
                    "event": "note[cpp/UseAfterFree/test]",
                    "message": "Use after free. DEVICE_2 is used in global::loop_detach after it may already have been freed with call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  188|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  189|   \tif (loop_device(DEVICE_2))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  190|-> \t\tloop_detach(DEVICE_2);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  191|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  192|   \tif (loop_device(DEVICE_3))",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 416,
            "tool": "snyk-code",
            "hash_v1": "2cf89680bdb3d7e3efc07d682f975f63509ab2e0",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/api-test-2.c",
                    "line": 555,
                    "column": 18,
                    "h_size": 8,
                    "event": "note[cpp/UseAfterFree/test]",
                    "message": "Use after free. DEVICE_3 is used in global::loop_device after it may already have been freed with call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  553|   \t\tloop_detach(DEVICE_2);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  554|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  555|-> \tif (loop_device(DEVICE_3))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  556|   \t\tloop_detach(DEVICE_3);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  557|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 416,
            "tool": "snyk-code",
            "hash_v1": "cc290c1548910bb40cfeff4daf88eb1732dacaa3",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/api-test.c",
                    "line": 192,
                    "column": 18,
                    "h_size": 8,
                    "event": "note[cpp/UseAfterFree/test]",
                    "message": "Use after free. DEVICE_3 is used in global::loop_device after it may already have been freed with call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  190|   \t\tloop_detach(DEVICE_2);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  191|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  192|-> \tif (loop_device(DEVICE_3))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  193|   \t\tloop_detach(DEVICE_3);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  194|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 416,
            "tool": "snyk-code",
            "hash_v1": "d3bf35edaf1167d95d5686ff818e024d35e79089",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/api-test-2.c",
                    "line": 556,
                    "column": 15,
                    "h_size": 8,
                    "event": "note[cpp/UseAfterFree/test]",
                    "message": "Use after free. DEVICE_3 is used in global::loop_detach after it may already have been freed with call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  554|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  555|   \tif (loop_device(DEVICE_3))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  556|-> \t\tloop_detach(DEVICE_3);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  557|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  558|   \tif (loop_device(DEVICE_4))",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 416,
            "tool": "snyk-code",
            "hash_v1": "2f892ba085ae0836b582d81a105a15de6b0930e8",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/api-test.c",
                    "line": 193,
                    "column": 15,
                    "h_size": 8,
                    "event": "note[cpp/UseAfterFree/test]",
                    "message": "Use after free. DEVICE_3 is used in global::loop_detach after it may already have been freed with call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  191|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  192|   \tif (loop_device(DEVICE_3))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  193|-> \t\tloop_detach(DEVICE_3);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  194|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  195|   \t_system(\"rm -f \" IMAGE_EMPTY, 0);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 416,
            "tool": "snyk-code",
            "hash_v1": "4e8c30c720169e0e415ee4671ec6ca7b6c9bc55f",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/api-test-2.c",
                    "line": 558,
                    "column": 18,
                    "h_size": 8,
                    "event": "note[cpp/UseAfterFree/test]",
                    "message": "Use after free. DEVICE_4 is used in global::loop_device after it may already have been freed with call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  556|   \t\tloop_detach(DEVICE_3);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  557|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  558|-> \tif (loop_device(DEVICE_4))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  559|   \t\tloop_detach(DEVICE_4);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  560|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 416,
            "tool": "snyk-code",
            "hash_v1": "7f25d54c069a1527bc1de061524fd07f2bbee285",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/api-test-2.c",
                    "line": 559,
                    "column": 15,
                    "h_size": 8,
                    "event": "note[cpp/UseAfterFree/test]",
                    "message": "Use after free. DEVICE_4 is used in global::loop_detach after it may already have been freed with call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  557|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  558|   \tif (loop_device(DEVICE_4))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  559|-> \t\tloop_detach(DEVICE_4);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  560|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  561|   \tif (loop_device(DEVICE_5))",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 416,
            "tool": "snyk-code",
            "hash_v1": "7facaa35aba8c7ddcfd7582e4b9b72a371926ac0",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/api-test-2.c",
                    "line": 561,
                    "column": 18,
                    "h_size": 8,
                    "event": "note[cpp/UseAfterFree/test]",
                    "message": "Use after free. DEVICE_5 is used in global::loop_device after it may already have been freed with call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  559|   \t\tloop_detach(DEVICE_4);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  560|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  561|-> \tif (loop_device(DEVICE_5))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  562|   \t\tloop_detach(DEVICE_5);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  563|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 416,
            "tool": "snyk-code",
            "hash_v1": "9fa124c0eb1b74ab02170264b3303d63b4b1fe80",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/api-test-2.c",
                    "line": 562,
                    "column": 15,
                    "h_size": 8,
                    "event": "note[cpp/UseAfterFree/test]",
                    "message": "Use after free. DEVICE_5 is used in global::loop_detach after it may already have been freed with call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  560|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  561|   \tif (loop_device(DEVICE_5))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  562|-> \t\tloop_detach(DEVICE_5);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  563|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  564|   \tif (loop_device(DEVICE_6))",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 416,
            "tool": "snyk-code",
            "hash_v1": "d3408fa6d6187fb5dc30f44183188e899e225bc3",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/api-test-2.c",
                    "line": 564,
                    "column": 18,
                    "h_size": 8,
                    "event": "note[cpp/UseAfterFree/test]",
                    "message": "Use after free. DEVICE_6 is used in global::loop_device after it may already have been freed with call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  562|   \t\tloop_detach(DEVICE_5);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  563|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  564|-> \tif (loop_device(DEVICE_6))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  565|   \t\tloop_detach(DEVICE_6);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  566|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 416,
            "tool": "snyk-code",
            "hash_v1": "9635c50b3b4eb3d6b0f7a53e85a7f793e4de667d",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/api-test-2.c",
                    "line": 565,
                    "column": 15,
                    "h_size": 8,
                    "event": "note[cpp/UseAfterFree/test]",
                    "message": "Use after free. DEVICE_6 is used in global::loop_detach after it may already have been freed with call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  563|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  564|   \tif (loop_device(DEVICE_6))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  565|-> \t\tloop_detach(DEVICE_6);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  566|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  567|   \t_system(\"rm -f \" IMAGE_EMPTY, 0);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 416,
            "tool": "snyk-code",
            "hash_v1": "ae063e049fe1ccca6fe79a1d162d5b96bad02c9b",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/api-test-2.c",
                    "line": 575,
                    "column": 10,
                    "h_size": 10,
                    "event": "note[cpp/UseAfterFree/test]",
                    "message": "Use after free. tmp_file_1 is used in remove after it may already have been freed with call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  573|   \t\tremove(test_loop_file);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  574|   \tif (tmp_file_1)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  575|-> \t\tremove(tmp_file_1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  576|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  577|   \tremove(REQS_LUKS2_HEADER);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 416,
            "tool": "snyk-code",
            "hash_v1": "35c9ce93a61686fee7b8aeceaf3179a315af66d3",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/api-test.c",
                    "line": 201,
                    "column": 10,
                    "h_size": 10,
                    "event": "note[cpp/UseAfterFree/test]",
                    "message": "Use after free. tmp_file_1 is used in remove after it may already have been freed with call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  199|   \t\tremove(test_loop_file);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  200|   \tif (tmp_file_1)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  201|-> \t\tremove(tmp_file_1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  202|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  203|   \tremove(EVL_HEADER_1);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 416,
            "tool": "snyk-code",
            "hash_v1": "99a334781b8b5c23f6798a337f3569344e5aa1a8",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/api-test.c",
                    "line": 199,
                    "column": 10,
                    "h_size": 14,
                    "event": "note[cpp/UseAfterFree/test]",
                    "message": "Use after free. test_loop_file is used in remove after it may already have been freed with call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  197|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  198|   \tif (test_loop_file)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  199|-> \t\tremove(test_loop_file);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  200|   \tif (tmp_file_1)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  201|   \t\tremove(tmp_file_1);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 416,
            "tool": "snyk-code",
            "hash_v1": "72c00721fddcad853e9a5fedad7a984e009b637b",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/lib/luks2/luks2_luks1_convert.c",
                    "line": 363,
                    "column": 37,
                    "h_size": 10,
                    "event": "warning[cpp/UseAfterFree]",
                    "message": "Use after free. base64_str is used in json_object_new_string_len after it may already have been freed with call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  361|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  362|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  363|-> \tfield = json_object_new_string_len(base64_str, base64_len);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  364|   \tfree(base64_str);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  365|   \tif (!field) {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 416,
            "tool": "snyk-code",
            "hash_v1": "e7da6e0b94189df3e86d0f6429f811c9807446a4",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/lib/luks2/luks2_luks1_convert.c",
                    "line": 875,
                    "column": 42,
                    "h_size": 3,
                    "event": "warning[cpp/UseAfterFree]",
                    "message": "Use after free. buf is used in memcpy after it may already have been freed with call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  873|   \t\t\tcontinue;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  874|   \t\t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  875|-> \t\tmemcpy(hdr1->keyblock[i].passwordSalt, buf, LUKS_SALTSIZE);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  876|   \t\tfree(buf);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  877|   \t}",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 416,
            "tool": "snyk-code",
            "hash_v1": "e6ac974198416492aa920a1f3f413cb86e8be06e",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/lib/luks2/luks2_digest_pbkdf2.c",
                    "line": 159,
                    "column": 71,
                    "h_size": 10,
                    "event": "warning[cpp/UseAfterFree]",
                    "message": "Use after free. base64_str is used in json_object_new_string after it may already have been freed with call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  157|   \t\treturn r;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  158|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  159|-> \tjson_object_object_add(jobj_digest, \"digest\", json_object_new_string(base64_str));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  160|   \tfree(base64_str);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  161|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 415,
            "tool": "snyk-code",
            "hash_v1": "8e11497d7cea46305c71e853819144b5a609ac6b",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/lib/luks2/luks2_luks1_convert.c",
                    "line": 364,
                    "column": 7,
                    "h_size": 10,
                    "event": "warning[cpp/DoubleFree]",
                    "message": "Potential double call to free. base64_str may have already been freed by call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  362|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  363|   \tfield = json_object_new_string_len(base64_str, base64_len);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  364|-> \tfree(base64_str);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  365|   \tif (!field) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  366|   \t\tjson_object_put(digest_obj);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 415,
            "tool": "snyk-code",
            "hash_v1": "f1bdec6c3e1d6e9daeef1f64759d6272f44463bd",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/lib/luks2/luks2_digest_pbkdf2.c",
                    "line": 160,
                    "column": 7,
                    "h_size": 10,
                    "event": "warning[cpp/DoubleFree]",
                    "message": "Potential double call to free. base64_str may have already been freed by call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  158|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  159|   \tjson_object_object_add(jobj_digest, \"digest\", json_object_new_string(base64_str));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  160|-> \tfree(base64_str);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  161|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  162|   \tif (jobj_digests) {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 415,
            "tool": "snyk-code",
            "hash_v1": "11fad722bccf5082b8214e3686098ecc85a2859d",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/lib/luks2/luks2_luks1_convert.c",
                    "line": 872,
                    "column": 9,
                    "h_size": 3,
                    "event": "warning[cpp/DoubleFree]",
                    "message": "Potential double call to free. buf may have already been freed by call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  870|   \t\t\tcontinue;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  871|   \t\tif (len > 0 && len != LUKS_SALTSIZE) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  872|-> \t\t\tfree(buf);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  873|   \t\t\tcontinue;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  874|   \t\t}",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 415,
            "tool": "snyk-code",
            "hash_v1": "11fad722bccf5082b8214e3686098ecc85a2859d",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/lib/luks2/luks2_luks1_convert.c",
                    "line": 876,
                    "column": 8,
                    "h_size": 3,
                    "event": "warning[cpp/DoubleFree]",
                    "message": "Potential double call to free. buf may have already been freed by call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  874|   \t\t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  875|   \t\tmemcpy(hdr1->keyblock[i].passwordSalt, buf, LUKS_SALTSIZE);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  876|-> \t\tfree(buf);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  877|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  878|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 23,
            "tool": "snyk-code",
            "hash_v1": "4e616d255938e189ab63b3d2976f2e43617d8080",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/misc/dict_search/crypt_dict.c",
                    "line": 37,
                    "column": 6,
                    "h_size": 5,
                    "event": "warning[cpp/PT]",
                    "message": "Unsanitized input from a command line argument flows into fopen, where it is used as a path. This may result in a Path Traversal vulnerability and allow an attacker to read arbitary files.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   35|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   36|   \t/* open password file, now in separate process */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   37|-> \tf = fopen(pwd_file, \"r\");",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   38|   \tif (!f) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   39|   \t\tprintf(\"Cannot open %s.\\n\", pwd_file);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 23,
            "tool": "snyk-code",
            "hash_v1": "39a6151998768701901e8739ffcd1e9c8b3c5aaf",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/misc/dict_search/crypt_dict.c",
                    "line": 133,
                    "column": 3,
                    "h_size": 5,
                    "event": "warning[cpp/PT]",
                    "message": "Unsanitized input from a command line argument flows into fopen, where it is used as a path. This may result in a Path Traversal vulnerability and allow an attacker to read arbitary files.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  131|   \t/* run scan in separate processes, it is up to scheduler to assign CPUs inteligently */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  132|   \tfor (i = 0; i < procs; i++)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  133|-> \t\tcheck(cd, argv[3], i, procs);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  134|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  135|   \t/* wait until at least one finishes with error or status 2 (key found) */",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 23,
            "tool": "snyk-code",
            "hash_v1": "a4fb5b4e95d6a57238bcdd47943e877765cc89b7",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/misc/keyslot_checker/chk_luks_keyslots.c",
                    "line": 314,
                    "column": 11,
                    "h_size": 4,
                    "event": "warning[cpp/PT]",
                    "message": "Unsanitized input from a command line argument flows into open, where it is used as a path. This may result in a Path Traversal vulnerability and allow an attacker to read arbitrary files.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  312|   \t* in the keyslots directly from the LUKS container.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  313|   \t*/",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  314|-> \tf_luks = open(device, O_RDONLY);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  315|   \tif (f_luks == -1) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  316|   \t\tfprintf(stderr,\"\\nError: Opening of device %s failed:\\n\", device);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 23,
            "tool": "snyk-code",
            "hash_v1": "7b41c21c39df3bf40b56521f8d14683d64acbcb0",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/lib/utils_loop.c",
                    "line": 282,
                    "column": 7,
                    "h_size": 4,
                    "event": "warning[cpp/PT]",
                    "message": "Unsanitized input from a file flows into open, where it is used as a path. This may result in a Path Traversal vulnerability and allow an attacker to read arbitrary files.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  280|   \t\treturn NULL;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  281|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  282|-> \tfd = open(buf, O_RDONLY);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  283|   \tif (fd < 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  284|   \t\treturn NULL;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 170,
            "tool": "snyk-code",
            "hash_v1": "5628939d27f68edeacd02cda6784e71b9860db3d",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/differ.c",
                    "line": 141,
                    "column": 7,
                    "h_size": 5,
                    "event": "note[cpp/ImproperNullTermination/test]",
                    "message": "Potential improperly null terminated input from a pointer to an input buffer flows into fopen, where it is used as a string. This may result in an information disclosure or buffer overflow vulnerability.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  139|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  140|   \tfor (i = 3; i < argc; i++)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  141|-> \t\tif (check(argv[i], file_old.addr, file_new.addr) == FAIL) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  142|   \t\t\tprintf (\"FAILED for %s\\n\", argv[i]);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  143|   \t\t\tr = 1;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 122,
            "tool": "snyk-code",
            "hash_v1": "56780d06db22319d0ef349facbd8b77a398caa27",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/lib/utils_io.c",
                    "line": 169,
                    "column": 3,
                    "h_size": 6,
                    "event": "warning[cpp/BufferOverflow]",
                    "message": "Unsanitized input from a file flows into memcpy, where it is used to manipulate application memory. This may result in a buffer overflow vulnerability.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  167|   \t\t\tgoto out;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  168|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  169|-> \t\tmemcpy((char *)buf + solid, hangover_buf, hangover);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  170|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  171|   \tret = length;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 122,
            "tool": "snyk-code",
            "hash_v1": "f35811f4d2364b0ab1ad396a31d1c5709cce623a",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/lib/utils_io.c",
                    "line": 176,
                    "column": 4,
                    "h_size": 6,
                    "event": "warning[cpp/BufferOverflow]",
                    "message": "Unsanitized input from a file flows into memcpy, where it is used to manipulate application memory. This may result in a buffer overflow vulnerability.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  174|   \tif (buf != orig_buf) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  175|   \t\tif (ret != -1)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  176|-> \t\t\tmemcpy(orig_buf, buf, length);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  177|   \t\tfree(buf);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  178|   \t}",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 122,
            "tool": "snyk-code",
            "hash_v1": "a0ffe66935136e6cebd40c5126483ee7e11f7825",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/lib/utils_io.c",
                    "line": 275,
                    "column": 3,
                    "h_size": 6,
                    "event": "warning[cpp/BufferOverflow]",
                    "message": "Unsanitized input from a file flows into memcpy, where it is used to manipulate application memory. This may result in a buffer overflow vulnerability.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  273|   \t\t\tgoto out;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  274|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  275|-> \t\tmemcpy(buf, (char*)frontPadBuf + frontHang, innerCount);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  276|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  277|   \t\tbuf = (char*)buf + innerCount;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 23,
            "tool": "snyk-code",
            "hash_v1": "80d7f6d10dd28fa95f4f8159738cda92f6ee66f3",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/differ.c",
                    "line": 96,
                    "column": 10,
                    "h_size": 4,
                    "event": "note[cpp/PT/test]",
                    "message": "Unsanitized input from a command line argument flows into open, where it is used as a path. This may result in a Path Traversal vulnerability and allow an attacker to read arbitrary files.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   94|   \tstruct stat st;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   95|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   96|-> \tf->fd = open(f->name, O_RDONLY);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   97|   \tif (f->fd == -1 || fstat(f->fd, &st) == -1)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   98|   \t\treturn 0;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 23,
            "tool": "snyk-code",
            "hash_v1": "94d17b012e62879e355d2397ac1ee2a21317e817",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/fuzz/proto_to_luks2.cc",
                    "line": 34,
                    "column": 8,
                    "h_size": 4,
                    "event": "note[cpp/PT/test]",
                    "message": "Unsanitized input from a command line argument flows into open, where it is used as a path. This may result in a Path Traversal vulnerability and allow an attacker to read arbitrary files.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   32|     }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   33|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   34|->   fd = open(argv[1], O_RDONLY);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   35|     if (fd < 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   36|       std::cerr << \"Failed to open \" << argv[1] << std::endl;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 23,
            "tool": "snyk-code",
            "hash_v1": "8a5c1b06794b97ae0417ca482a355a27c7cbb303",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/fuzz/proto_to_luks2.cc",
                    "line": 52,
                    "column": 8,
                    "h_size": 4,
                    "event": "note[cpp/PT/test]",
                    "message": "Unsanitized input from a command line argument flows into open, where it is used as a path. This may result in a Path Traversal vulnerability and allow an attacker to read arbitrary files.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   50|     out_img_name += \".img\";",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   51|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   52|->   fd = open(out_img_name.c_str(), O_RDWR|O_CREAT|O_EXCL|O_CLOEXEC|O_TRUNC, 0644);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   53|     if (fd < 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   54|       std::cerr << \"Failed to open output file \" << out_img_name << std::endl;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 23,
            "tool": "snyk-code",
            "hash_v1": "80226434f3e4c4700fd32289c625703420df06a6",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/fuzz/plain_json_proto_to_luks2.cc",
                    "line": 34,
                    "column": 8,
                    "h_size": 4,
                    "event": "note[cpp/PT/test]",
                    "message": "Unsanitized input from a command line argument flows into open, where it is used as a path. This may result in a Path Traversal vulnerability and allow an attacker to read arbitrary files.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   32|     }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   33|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   34|->   fd = open(argv[1], O_RDONLY);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   35|     if (fd < 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   36|       std::cerr << \"Failed to open \" << argv[1] << std::endl;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 23,
            "tool": "snyk-code",
            "hash_v1": "981b3c389bfbf4a24563c60ed475e48a306dbc62",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/fuzz/plain_json_proto_to_luks2.cc",
                    "line": 52,
                    "column": 8,
                    "h_size": 4,
                    "event": "note[cpp/PT/test]",
                    "message": "Unsanitized input from a command line argument flows into open, where it is used as a path. This may result in a Path Traversal vulnerability and allow an attacker to read arbitrary files.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   50|     out_img_name += \".img\";",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   51|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   52|->   fd = open(out_img_name.c_str(), O_RDWR|O_CREAT|O_EXCL|O_CLOEXEC|O_TRUNC, 0644);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   53|     if (fd < 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   54|       std::cerr << \"Failed to open output file \" << out_img_name << std::endl;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 23,
            "tool": "snyk-code",
            "hash_v1": "39b4de95a51295f6ef4e4f117d215f8532024386",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/unit-utils-io.c",
                    "line": 48,
                    "column": 7,
                    "h_size": 4,
                    "event": "note[cpp/PT/test]",
                    "message": "Unsanitized input from a command line argument flows into open, where it is used as a path. This may result in a Path Traversal vulnerability and allow an attacker to read arbitrary files.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   46|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   47|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   48|-> \tfd = open(test_file, O_RDONLY | O_DIRECT);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   49|   \tif (fd < 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   50|   \t\tfprintf(stderr, \"Failed to open %s.\\n\", test_file);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 23,
            "tool": "snyk-code",
            "hash_v1": "0a4a6a58eba861a01e4566d50d6fdb0355c5fd06",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/unit-utils-io.c",
                    "line": 79,
                    "column": 7,
                    "h_size": 4,
                    "event": "note[cpp/PT/test]",
                    "message": "Unsanitized input from a command line argument flows into open, where it is used as a path. This may result in a Path Traversal vulnerability and allow an attacker to read arbitrary files.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   77|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   78|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   79|-> \tfd = open(test_file, O_WRONLY | O_DIRECT);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   80|   \tif (fd < 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   81|   \t\tfprintf(stderr, \"Failed to open %s.\\n\", test_file);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 23,
            "tool": "snyk-code",
            "hash_v1": "39b4de95a51295f6ef4e4f117d215f8532024386",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/unit-utils-io.c",
                    "line": 111,
                    "column": 7,
                    "h_size": 4,
                    "event": "note[cpp/PT/test]",
                    "message": "Unsanitized input from a command line argument flows into open, where it is used as a path. This may result in a Path Traversal vulnerability and allow an attacker to read arbitrary files.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  109|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  110|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  111|-> \tfd = open(test_file, O_RDONLY | O_DIRECT);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  112|   \tif (fd < 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  113|   \t\tfprintf(stderr, \"Failed to open %s.\\n\", test_file);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 23,
            "tool": "snyk-code",
            "hash_v1": "5273684d2e02047455ba20d8afb8b634fc8ede4a",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/unit-utils-io.c",
                    "line": 143,
                    "column": 7,
                    "h_size": 4,
                    "event": "note[cpp/PT/test]",
                    "message": "Unsanitized input from a command line argument flows into open, where it is used as a path. This may result in a Path Traversal vulnerability and allow an attacker to read arbitrary files.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  141|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  142|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  143|-> \tfd = open(test_file, O_RDWR | O_DIRECT);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  144|   \tif (fd < 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  145|   \t\tfprintf(stderr, \"Failed to open %s.\\n\", test_file);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 23,
            "tool": "snyk-code",
            "hash_v1": "39b4de95a51295f6ef4e4f117d215f8532024386",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/unit-utils-io.c",
                    "line": 174,
                    "column": 7,
                    "h_size": 4,
                    "event": "note[cpp/PT/test]",
                    "message": "Unsanitized input from a command line argument flows into open, where it is used as a path. This may result in a Path Traversal vulnerability and allow an attacker to read arbitrary files.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  172|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  173|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  174|-> \tfd = open(test_file, O_RDONLY | O_DIRECT);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  175|   \tif (fd < 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  176|   \t\tfprintf(stderr, \"Failed to open %s.\\n\", test_file);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 23,
            "tool": "snyk-code",
            "hash_v1": "5273684d2e02047455ba20d8afb8b634fc8ede4a",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/unit-utils-io.c",
                    "line": 205,
                    "column": 7,
                    "h_size": 4,
                    "event": "note[cpp/PT/test]",
                    "message": "Unsanitized input from a command line argument flows into open, where it is used as a path. This may result in a Path Traversal vulnerability and allow an attacker to read arbitrary files.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  203|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  204|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  205|-> \tfd = open(test_file, O_RDWR | O_DIRECT);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  206|   \tif (fd < 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  207|   \t\tfprintf(stderr, \"Failed to open %s.\\n\", test_file);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 23,
            "tool": "snyk-code",
            "hash_v1": "c584c1be68a88504c2fb73a13e53115173fad585",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/differ.c",
                    "line": 141,
                    "column": 7,
                    "h_size": 5,
                    "event": "note[cpp/PT/test]",
                    "message": "Unsanitized input from a command line argument flows into fopen, where it is used as a path. This may result in a Path Traversal vulnerability and allow an attacker to read arbitary files.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  139|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  140|   \tfor (i = 3; i < argc; i++)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  141|-> \t\tif (check(argv[i], file_old.addr, file_new.addr) == FAIL) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  142|   \t\t\tprintf (\"FAILED for %s\\n\", argv[i]);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  143|   \t\t\tr = 1;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 415,
            "tool": "snyk-code",
            "hash_v1": "36ab41e7d7abe3b809230c24f4a99abbf926207d",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/api-test-2.c",
                    "line": 587,
                    "column": 7,
                    "h_size": 10,
                    "event": "note[cpp/DoubleFree/test]",
                    "message": "Potential double call to free. tmp_file_1 may have already been freed by call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  585|   \t_remove_keyfiles();",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  586|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  587|-> \tfree(tmp_file_1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  588|   \tfree(test_loop_file);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  589|   \tfree(THE_LOOP_DEV);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 415,
            "tool": "snyk-code",
            "hash_v1": "1523b4cd855cb43d77568b7bc6c4e6061a1ee9e8",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/api-test.c",
                    "line": 213,
                    "column": 7,
                    "h_size": 10,
                    "event": "note[cpp/DoubleFree/test]",
                    "message": "Potential double call to free. tmp_file_1 may have already been freed by call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  211|   \t_remove_keyfiles();",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  212|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  213|-> \tfree(tmp_file_1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  214|   \tfree(test_loop_file);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  215|   \tfree(THE_LOOP_DEV);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 415,
            "tool": "snyk-code",
            "hash_v1": "0b32c90adb103854233ab4b5d8fa6846a05ae967",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/api-test.c",
                    "line": 214,
                    "column": 7,
                    "h_size": 14,
                    "event": "note[cpp/DoubleFree/test]",
                    "message": "Potential double call to free. test_loop_file may have already been freed by call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  212|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  213|   \tfree(tmp_file_1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  214|-> \tfree(test_loop_file);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  215|   \tfree(THE_LOOP_DEV);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  216|   \tfree(DEVICE_1);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 415,
            "tool": "snyk-code",
            "hash_v1": "8efeeb5399036de51630b1662c782430625e2dce",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/api-test-2.c",
                    "line": 590,
                    "column": 7,
                    "h_size": 8,
                    "event": "note[cpp/DoubleFree/test]",
                    "message": "Potential double call to free. DEVICE_1 may have already been freed by call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  588|   \tfree(test_loop_file);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  589|   \tfree(THE_LOOP_DEV);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  590|-> \tfree(DEVICE_1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  591|   \tfree(DEVICE_2);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  592|   \tfree(DEVICE_3);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 415,
            "tool": "snyk-code",
            "hash_v1": "f4762f2edc970c2c5279e3b06d0a77537acb954c",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/api-test.c",
                    "line": 216,
                    "column": 7,
                    "h_size": 8,
                    "event": "note[cpp/DoubleFree/test]",
                    "message": "Potential double call to free. DEVICE_1 may have already been freed by call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  214|   \tfree(test_loop_file);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  215|   \tfree(THE_LOOP_DEV);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  216|-> \tfree(DEVICE_1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  217|   \tfree(DEVICE_2);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  218|   \tfree(DEVICE_3);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 415,
            "tool": "snyk-code",
            "hash_v1": "2316b249c4c72e87eb2547794c61392e491bc943",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/api-test-2.c",
                    "line": 591,
                    "column": 7,
                    "h_size": 8,
                    "event": "note[cpp/DoubleFree/test]",
                    "message": "Potential double call to free. DEVICE_2 may have already been freed by call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  589|   \tfree(THE_LOOP_DEV);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  590|   \tfree(DEVICE_1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  591|-> \tfree(DEVICE_2);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  592|   \tfree(DEVICE_3);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  593|   \tfree(DEVICE_4);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 415,
            "tool": "snyk-code",
            "hash_v1": "789c62f6d5ac5e863fbd6ba03fd34679d2090ae1",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/api-test.c",
                    "line": 217,
                    "column": 7,
                    "h_size": 8,
                    "event": "note[cpp/DoubleFree/test]",
                    "message": "Potential double call to free. DEVICE_2 may have already been freed by call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  215|   \tfree(THE_LOOP_DEV);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  216|   \tfree(DEVICE_1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  217|-> \tfree(DEVICE_2);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  218|   \tfree(DEVICE_3);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  219|   }",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 415,
            "tool": "snyk-code",
            "hash_v1": "2355782385ddf0f09c93795f4c411446282b2415",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/api-test-2.c",
                    "line": 592,
                    "column": 7,
                    "h_size": 8,
                    "event": "note[cpp/DoubleFree/test]",
                    "message": "Potential double call to free. DEVICE_3 may have already been freed by call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  590|   \tfree(DEVICE_1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  591|   \tfree(DEVICE_2);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  592|-> \tfree(DEVICE_3);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  593|   \tfree(DEVICE_4);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  594|   \tfree(DEVICE_5);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 415,
            "tool": "snyk-code",
            "hash_v1": "1dd53eea9290530de0cfc439f0b05f68b2da4356",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/api-test.c",
                    "line": 218,
                    "column": 7,
                    "h_size": 8,
                    "event": "note[cpp/DoubleFree/test]",
                    "message": "Potential double call to free. DEVICE_3 may have already been freed by call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  216|   \tfree(DEVICE_1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  217|   \tfree(DEVICE_2);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  218|-> \tfree(DEVICE_3);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  219|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  220|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 415,
            "tool": "snyk-code",
            "hash_v1": "f20f75b713f618879de29785468025714ac40c37",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/api-test-2.c",
                    "line": 593,
                    "column": 7,
                    "h_size": 8,
                    "event": "note[cpp/DoubleFree/test]",
                    "message": "Potential double call to free. DEVICE_4 may have already been freed by call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  591|   \tfree(DEVICE_2);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  592|   \tfree(DEVICE_3);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  593|-> \tfree(DEVICE_4);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  594|   \tfree(DEVICE_5);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  595|   \tfree(DEVICE_6);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 415,
            "tool": "snyk-code",
            "hash_v1": "ba21a1fd7de4881bd6e773d6d0c8c569bb3a09a2",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/api-test-2.c",
                    "line": 594,
                    "column": 7,
                    "h_size": 8,
                    "event": "note[cpp/DoubleFree/test]",
                    "message": "Potential double call to free. DEVICE_5 may have already been freed by call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  592|   \tfree(DEVICE_3);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  593|   \tfree(DEVICE_4);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  594|-> \tfree(DEVICE_5);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  595|   \tfree(DEVICE_6);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  596|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 415,
            "tool": "snyk-code",
            "hash_v1": "778e29af74a177a6bbe5e4a3bef7348dbba5b80a",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/api-test-2.c",
                    "line": 595,
                    "column": 7,
                    "h_size": 8,
                    "event": "note[cpp/DoubleFree/test]",
                    "message": "Potential double call to free. DEVICE_6 may have already been freed by call to free.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  593|   \tfree(DEVICE_4);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  594|   \tfree(DEVICE_5);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  595|-> \tfree(DEVICE_6);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  596|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  597|   #ifdef KERNEL_KEYRING",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 170,
            "tool": "snyk-code",
            "hash_v1": "b75726c2d7291144d12b0ee9f8b33e81dcddba9d",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/src/utils_password.c",
                    "line": 251,
                    "column": 14,
                    "h_size": 6,
                    "event": "note[cpp/ImproperNullTermination]",
                    "message": "Potential improperly null terminated input from a pointer to an input buffer flows into strlen, where it is used as a string. This may result in an information disclosure or buffer overflow vulnerability.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  249|   \t*key = pass;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  250|   \t/* coverity[string_null] (crypt_safe_alloc wipes string with additional \\0) */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  251|-> \t*key_size = strlen(pass);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  252|   \tr = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  253|   out:",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 170,
            "tool": "snyk-code",
            "hash_v1": "d142c777b4c402672ad15c2de134057731ab1e55",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/lib/fvault2/fvault2.c",
                    "line": 384,
                    "column": 68,
                    "h_size": 6,
                    "event": "note[cpp/ImproperNullTermination]",
                    "message": "Potential improperly null terminated input from a pointer to an input buffer flows into strlen, where it is used as a string. This may result in an information disclosure or buffer overflow vulnerability.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  382|   \tif (r < 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  383|   \t\tgoto out;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  384|-> \tr = crypt_base64_decode((char **)&pwk, &decoded_size, pwk_base64, strlen(pwk_base64));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  385|   \tif (r < 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  386|   \t\tgoto out;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 170,
            "tool": "snyk-code",
            "hash_v1": "4deecd4fe702659f61d0941e7447e6e24707843a",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/lib/fvault2/fvault2.c",
                    "line": 395,
                    "column": 70,
                    "h_size": 6,
                    "event": "note[cpp/ImproperNullTermination]",
                    "message": "Potential improperly null terminated input from a pointer to an input buffer flows into strlen, where it is used as a string. This may result in an information disclosure or buffer overflow vulnerability.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  393|   \tif (r < 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  394|   \t\tgoto out;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  395|-> \tr = crypt_base64_decode((char **)&kwvk, &decoded_size, kwvk_base64, strlen(kwvk_base64));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  396|   \tif (r < 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  397|   \t\tgoto out;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 122,
            "tool": "snyk-code",
            "hash_v1": "a00e28fb177817b44f7c034c50f49cd422b87712",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/lib/utils_crypt.c",
                    "line": 29,
                    "column": 6,
                    "h_size": 6,
                    "event": "warning[cpp/UnsafeFunctionStringHandling]",
                    "message": "Using sscanf can lead to buffer overflow vulnerabilities, if arbitrary user input is able to flow into this function without the length of the input being checked. Use the safer alternative sscanf_s instead.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   27|   \t\treturn -EINVAL;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   28|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   29|-> \tif (sscanf(s, \"%\" MAX_CIPHER_LEN_STR \"[^-]-%\" MAX_CIPHER_LEN_STR \"s\",",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   30|   \t\t   cipher, cipher_mode) == 2) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   31|   \t\tif (!strncmp(cipher, \"capi:\", 5)) {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 122,
            "tool": "snyk-code",
            "hash_v1": "cc9bc244aceadc2cf44419868f3f9208780fba75",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/lib/utils_crypt.c",
                    "line": 60,
                    "column": 6,
                    "h_size": 6,
                    "event": "warning[cpp/UnsafeFunctionStringHandling]",
                    "message": "Using sscanf can lead to buffer overflow vulnerabilities, if arbitrary user input is able to flow into this function without the length of the input being checked. Use the safer alternative sscanf_s instead.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   58|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   59|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   60|-> \tif (sscanf(s, \"%\" MAX_CIPHER_LEN_STR \"[^-]\", cipher) == 1) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   61|   \t\tif (strncmp(cipher, \"capi:\", 5))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   62|   \t\t\tstrcpy(cipher_mode, \"cbc-plain\");",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SNYK_CODE_WARNING",
            "cwe": 78,
            "tool": "snyk-code",
            "hash_v1": "29ab7ba6b27720f813a9552cf069574843500745",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/cryptsetup-2.8.0-git/tests/all-symbols-test.c",
                    "line": 152,
                    "column": 6,
                    "h_size": 6,
                    "event": "note[cpp/CommandInjection/test]",
                    "message": "Unsanitized input from a command line argument flows into dlopen, where it is used as a shell command. This may result in a Command Injection vulnerability.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  150|   \tlog_std(\"Checking dlopen(%s)...\", libfile);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  151|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  152|-> \th = dlopen(libfile, RTLD_NOW);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  153|   \tif (!h) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  154|   \t\tlog_err(\"dlopen(): %s.\", dlerror());",
                    "verbosity_level": 1
                }
            ]
        }
    ]
}
